var fontPreview =
{
	init: function(e)
	{
		window.removeEventListener("load", this, false);
		var text = nsPreferences.copyUnicharPref("extensions.fontpreview.sample", "");
		this.serifTextbox     = document.getElementById("serif_preview");
		this.sansSerifTextbox = document.getElementById("sans-serif_preview");
		this.monospaceTextbox = document.getElementById("monospace_preview");
		this.serifTextbox.value     = text;
		this.sansSerifTextbox.value = text;
		this.monospaceTextbox.value = text;
		this.serif     = document.getElementById("serif");
		this.sansSerif = document.getElementById("sans-serif");
		this.monospace = document.getElementById("monospace");
		this.sizeVar   = document.getElementById("sizeVar");
		this.sizeMono  = document.getElementById("sizeMono");
		this.serif.addEventListener("DOMAttrModified", this, false);
		this.sansSerif.addEventListener("DOMAttrModified", this, false);
		this.monospace.addEventListener("DOMAttrModified", this, false);
		this.sizeVar.addEventListener("DOMAttrModified", this, false);
		this.sizeMono.addEventListener("DOMAttrModified", this, false);
		this.reflect();
	},
	destroy: function()
	{
		window.removeEventListener("unload", this, false);
		this.serif.removeEventListener("DOMAttrModified", this, false);
		this.sansSerif.removeEventListener("DOMAttrModified", this, false);
		this.monospace.removeEventListener("DOMAttrModified", this, false);
		this.sizeVar.removeEventListener("DOMAttrModified", this, false);
		this.sizeMono.removeEventListener("DOMAttrModified", this, false);
	},
	reflect: function()
	{
		this.serifTextbox.style.fontFamily     = "'" + this.serif.value + "'";
		this.sansSerifTextbox.style.fontFamily = "'" + this.sansSerif.value + "'";
		this.monospaceTextbox.style.fontFamily = "'" + this.monospace.value + "'";
		this.serifTextbox.style.fontSize       = this.sizeVar.value + "px";
		this.sansSerifTextbox.style.fontSize   = this.sizeVar.value + "px";
		this.monospaceTextbox.style.fontSize   = this.sizeMono.value + "px";
	},
	handleEvent: function(e)
	{
		switch(e.type)
		{
			case "load":
				this.init();
				return;
			case "unload":
				this.destroy();
				return;
			case "DOMAttrModified":
				this.reflect();
				return;
		}
	}
}
window.addEventListener("load", fontPreview, false);
window.addEventListener("unload", fontPreview, false);